## org.biojava.bio.seq.db
Interface SequenceDB

All Superinterfaces:
  Changeable, SequenceDBLite

All Known Subinterfaces:
  RichSequenceDB

All Known Implementing Classes:
  AbstractRichSequenceDB, AbstractSequenceDB, AnnotatedSequenceDB, BioSQLRichSequenceDB, BioSQLSequenceDB, CachingSequenceDB, DASSequenceDB, DistributedSequenceDB, DummySequenceDB, GenbankRichSequenceDB, GenpeptRichSequenceDB, HashRichSequenceDB, HashSequenceDB, IndexedSequenceDB, SequenceDBWrapper, SubSequenceDB, ViewingSequenceDB

    public interface SequenceDB

extends SequenceDBLite

A database of sequences with accessible keys and iterators over all sequences.

This may have several implementations with rich behaviour, but basically most of the time you will just use the interface methods to do stuff. A sequence database contains a finite number of sequences stored under unique keys.

Author:
  Matthew Pocock, Gerald Loeffler, Thomas Down

Field Summary

Fields inherited from interface org.biojava.bio.seq.db.SequenceDBLite
`SEQUENCES`

Method Summary
`FeatureHolder` `filter(FeatureFilter filter)` Query features attached to all sequences in this database.
`Set` `ids()` Get an immutable set of all of the IDs in the database.
`SequenceIterator` `sequenceIterator()` Returns a SequenceIterator over all sequences in the database.

Methods inherited from interface org.biojava.bio.seq.db.SequenceDBLite
`addSequence, getName, getSequence, removeSequence`

Methods inherited from interface org.biojava.utils.Changeable
`addChangeListener, addChangeListener, isUnchanging, removeChangeListener, removeChangeListener`

Method Detail

### ids

    Set ids()

  Get an immutable set of all of the IDs in the database. The ids are legal arguments to getSequence.

  Returns:
    a Set of ids - at the moment, strings

### sequenceIterator

    SequenceIterator sequenceIterator()

  Returns a SequenceIterator over all sequences in the database. The order of retrieval is undefined.

  Returns:
    a SequenceIterator over all sequences

### filter

    FeatureHolder filter(FeatureFilter filter)

  Query features attached to all sequences in this database. This is equivalent to applying `filter` to all sequences then merging the results.

  Parameters:
    `filter` - a `FeatureFilter`.
  Since:
    1.3